'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref) {
  var t = _ref.types;

  var className = void 0;

  return {
    name: 'babel-plugin-component-identification',
    visitor: {
      ClassDeclaration: function ClassDeclaration(_ref2) {
        var name = _ref2.node.id.name;

        className = name;
      },
      ReturnStatement: function ReturnStatement(path) {
        var _argument$openingElem;

        var argument = path.node.argument;

        if (argument.type !== 'JSXElement') {
          return;
        }

        var _path$getFunctionPare = path.getFunctionParent(),
            parentId = _path$getFunctionPare.node.id,
            functionalComponent = _path$getFunctionPare.parent;

        var isClassRenderMethod = className && parentId && parentId.name === 'render';
        var identity = 'unknown';

        if (isClassRenderMethod) {
          identity = className;
        } else if (functionalComponent) {
          identity = functionalComponent.id.name;
        }

        var newAttributes = [t.jSXAttribute(t.jSXIdentifier('data-component-id'), t.stringLiteral(identity))];

        (_argument$openingElem = argument.openingElement.attributes).push.apply(_argument$openingElem, newAttributes);
      }
    }
  };
};